@echo off
if %1 == genhdr goto genhdr
if %1 == genlib goto genlib
echo Usage: "win32iconv genhdr" or "win32iconv genlib build-type"
exit 1

@rem Generate the apr_config_iconv.h header
:genhdr
set hdr=.\include\apr_config_iconv.h
type .\include\apr_config_iconv.hw > %hdr%
if not exist i18n\win32\libiconv\include\iconv.h.msvc-static exit 0
if not exist i18n\win32\libiconv\include\iconv.h.msvc-shared exit 0

@rem Define config constants
echo #ifdef APR_WIN32_CONFIG_ICONV_PRIVATE >> %hdr%
echo #define HAVE_ICONV 1 >> %hdr%
echo #define HAVE_ICONV_H 1 >> %hdr%
echo #else  /* !APR_WIN32_CONFIG_ICONV_PRIVATE */ >> %hdr%
echo #define APR_HAS_XLATE 1 >> %hdr%
echo #endif /* !APR_WIN32_CONFIG_ICONV_PRIVATE */ >> %hdr%
exit 0


@rem Build libconv
:genlib
if %2 == libdbg goto libdbg
if %2 == librel goto librel
if %2 == dlldbg goto dlldbg
if %2 == dllrel goto dllrel
echo Usage: "win32iconv genlib build-type"
echo build-type must be one of: libdbg, librel, dlldbg or dllrel
exit 1

:libdbg
set mflags=-MDd
set outdir=LibD
set debug=1
set dll=0
goto build

:librel
set mflags=-MD
set outdir=LibR
set debug=0
set dll=0
goto build

:dlldbg
set mflags=-MDd
set outdir=Debug
set debug=1
set dll=1
goto build

:dllrel
set mflags=-MD
set outdir=Release
set debug=0
set dll=1
goto build

:build
if not exist i18n\win32\libiconv\include\iconv.h.msvc-static goto dummy
if not exist i18n\win32\libiconv\include\iconv.h.msvc-shared goto dummy

@rem Without this, iconv.exe won't build (as of libiconv-1.8)
set mflags=%mflags% -DNO_I18N -DLOCALEDIR=\\\"\\\"

cd i18n\win32\libiconv
nmake -f Makefile.msvc MFLAGS="%mflags%" DEBUG="%debug%" DLL="%dll%" clean all
if not errorlevel 0 exit 1
copy lib\iconv.lib ..\..\..\%outdir%\
if not exist ..\..\..\%outdir%\iconv.lib exit 1
if not exist lib\iconv.dll exit 0
copy lib\iconv.dll ..\..\..\%outdir%\
if not exist ..\..\..\%outdir%\iconv.dll exit 1
exit 0

:dummy
cd %outdir%
nmake -f ..\i18n\win32\Makefile MFLAGS="%mflags%" SRCDIR=..\i18n\win32
if not errorlevel 0 exit 1
exit 0
